#!/usr/bin/env ruby
#
# A Ruby library for interacting with system-level MIDI services.
#
# == Authors
#
# * Ben Bleything <ben@bleything.net>
#
# == Copyright
#
# Copyright (c) 2008 Ben Bleything
#
# This code released under the terms of the MIT license.
#

module MIDIator
  VERSION = "0.3.1"
end

#####################################################################
###  C O R E   L I B R A R Y   E X T E N S I O N S
#####################################################################
require File.expand_path("../string_extensions", __FILE__)

#####################################################################
###  M I D I A T O R   C O R E
#####################################################################
require File.expand_path( "../driver", __FILE__)
require File.expand_path( "../driver_registry", __FILE__)
require File.expand_path( "../exceptions", __FILE__)
require File.expand_path( "../interface", __FILE__)
require File.expand_path( "../timer", __FILE__)

##########################################################################
### S H O R T C U T   M O D U L E S
##########################################################################
require File.expand_path( "../drums", __FILE__)
require File.expand_path( "../notes", __FILE__)
